#include "IMAGraphicsView.h"
#include "DebugText.hpp"


IMAGraphicsView::IMAGraphicsView(QGraphicsView * parent) {
	setFrameShadow(Sunken);
	setFrameShape(NoFrame);
	//ViewСʾ
	setMinimumHeight(400);
	setMinimumWidth(300);
	//Ⱦ򿹾
	setRenderHint(QPainter::Antialiasing);

	getMap("Icons/background.png");
	
	
	setScene(&scene);
	//scene.setBackgroundBrush(QColor(0, 255, 255, 255));

	setCacheMode(CacheBackground);
	scale(_scale, _scale);
}

IMAGraphicsView::~IMAGraphicsView() {
	


}


void IMAGraphicsView::mouseMoveEvent(QMouseEvent *event) {

}

void IMAGraphicsView::mousePressEvent(QMouseEvent *event) {
	//QGraphicsView 
	QPoint viewPoint = event->pos();
	//QGraphicsScene 
	QPointF scenePoint = mapToScene(viewPoint);
	DebugText::getDebugText()->addContents(QString::number(scenePoint.x())+" "+ QString::number(scenePoint.y()));
}

void IMAGraphicsView::mouseReleaseEvent(QMouseEvent *event) {
	//QGraphicsView 
	QPoint viewPoint = event->pos();
	//QGraphicsScene 
	QPointF scenePoint = mapToScene(viewPoint);
	DebugText::getDebugText()->addContents(QString::number(scenePoint.x()) + " " + QString::number(scenePoint.y()));
}

void IMAGraphicsView::drawBackground(QPainter *painter, const QRectF &rect) {
	painter->drawPixmap(int(sceneRect().left()), int(sceneRect().top()), map);
	
}

void IMAGraphicsView::getMap(QString mapname) {
	map.load(mapname);

	width = map.width();
	height = map.height();
	bottom = -0.5 * height;
	left = -0.5 * width;

	scene.setSceneRect(left, bottom, width, height);
}

void IMAGraphicsView::wheelEvent(QWheelEvent *event)
{
	if (event->delta() > 0) {
		_scale = 1.1f;
	}
	else {
		_scale = 0.9f; 
	}
	scale(_scale, _scale); 
}

void IMAGraphicsView::PaintBuffer(Dinodon::Uchar* buffer, int width, int height, int channals) {
	QImage::Format format;
	if (channals == 4) format = QImage::Format_ARGB32;
	else if (channals == 3) format = QImage::Format_RGB888;
	QImage image(buffer, width, height, static_cast<int>(width * channals * sizeof(unsigned char)), format);
	image.constBits();
	map = QPixmap::fromImage(image.rgbSwapped());

	width = map.width();
	height = map.height();
	bottom = -0.5 * height;
	left = -0.5 * width;
	scene.setSceneRect(left, bottom, width, height);

	setScene(&scene);
	scale(0.5, 0.5);
	scale(2.0, 2.0);
}

